Imports System.IO
Imports System.Data
Imports System.Data.OleDb

Module Conexion
    'La ruta de conexin con la base de datos y el proveedor
    Dim Ruta As String = My.Application.Info.DirectoryPath & "\AgendaTelefonica.mdb"
    Dim Conectar As New OleDbConnection("Provider=Microsoft.Jet.OLEDB.4.0;Data Source=" & Ruta & "")

    Public Function ObtenerConexion(ByRef Estado As String) As OleDbConnection
        Try
            If Conectar.State <> ConnectionState.Open Then
                Conectar.Open()
                Estado = "Conexin abierta"
            End If
            Return Conectar

        Catch ex As OleDbException
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Error de Coneccin")
            Return Nothing
        End Try
    End Function

    Public Sub CerrarConexion(ByRef Estado As String)
        Try
            If Conectar.State <> ConnectionState.Closed Then
                Estado = "Conexin cerrada"
                Conectar.Close()
            End If

        Catch ex As OleDbException
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Error de Coneccin")

        End Try
    End Sub

    Public Function CrearTabla() As Boolean
        Dim Creada As Boolean = False

        Dim Crear As String = "CREATE TABLE TablaContactos" + _
        "( Id AUTOINCREMENT CONSTRAINT PKEY Primary Key," + _
        "Nombre VARCHAR(50) DEFAULT NULL,Apellidos VARCHAR(100)DEFAULT NULL," + _
        "Direccion VARCHAR(100)DEFAULT NULL,Telefono NUMERIC(12)DEFAULT 0," + _
        "Movil NUMERIC(12)DEFAULT 0,Email VARCHAR(50)DEFAULT NULL," + _
        "Url VARCHAR(50)DEFAULT NULL,Comentarios VARCHAR(255)DEFAULT NULL," + _
        "Cita VARCHAR(15)DEFAULT NULL,Hora VARCHAR(10)DEFAULT NULL)"

        Try
            Conectar.Open()
            Dim Comando As New OleDbCommand(Crear, Conectar)
            Comando.ExecuteNonQuery()
            Creada = True

            If Creada = True Then
                MsgBox("La tabla se ha creado exitosamente," & _
                " Para agregar un nuevo usuario, debe hacer clic en el Boton 'Nuevo'", _
                MsgBoxStyle.Information, "Tabla Creada")
                Conectar.Close()
            End If

        Catch ex As Exception
            MsgBox("Error al crear la tabla:" & vbCrLf & ex.Message, MsgBoxStyle.Critical, "Error")
        Finally

        End Try

        Return Creada
    End Function

    Public Function ExisteTabla()
        Dim Respuesta As Integer
        Dim dt As New DataTable
        ' Devuelve True si la tabla existe
        Dim Existe As Boolean = False
        Try
            Dim da As New OleDbDataAdapter("SELECT * FROM TablaContactos", Conectar)
            da.Fill(dt)
            Return Existe
        Catch ex As OleDb.OleDbException
            Respuesta = MsgBox("No existe la Tabla en la base de datos del programa," + _
            " desea crearla?.", MsgBoxStyle.OkCancel, "Crear Tabla")
            If Respuesta = 1 Then
                CrearTabla()
            End If
            If Respuesta = 2 Then End
            Return False
        End Try
    End Function

    Public Function ExisteBase()
        Dim Respuesta As Integer
        Dim base As Boolean
        Try
            If File.Exists(Ruta) Then
                base = True
            Else
                base = False
                Respuesta = MsgBox("La base de datos necesaria para el funcionamiento del programa NO existe," + _
                " desea crearla?.", MsgBoxStyle.OkCancel, "Crear Base de Datos")
                If Respuesta = 1 Then
                    CrearBase()
                    CrearTabla()
                End If
                If Respuesta = 2 Then End
            End If

        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.Critical, "Existe Base?")
        End Try
        Return base
    End Function

    Public Function CrearBase()
        Dim Creada As Boolean
        Dim Crear As New ADOX.Catalog()
        Try
            Dim Proveedor As String
            Proveedor = "Provider=Microsoft.Jet.OLEDB.4.0;Data Source="
            Crear.Create(Proveedor & Ruta)
            Creada = True
            MsgBox("La base de datos se ha creado exitosamente, ahora se crear la " + _
            "'Tabla' necesaria para el funcionamiento del programa.", MsgBoxStyle.OkCancel, "Crear Base de Datos")
        Catch Excep As System.Runtime.InteropServices.COMException
            MsgBox(Excep.Message, MsgBoxStyle.Critical, "Error")
            Creada = False
        Finally
            Crear = Nothing
        End Try
        Return Creada
    End Function

End Module
